#include "deriv2_private2.hpp"

void
T1::dispatch_m(Base1 *Base1_o)
{
  Base1_o->_forward_m(this);
}

void
T1::dispatch_m(Deriv1 *Deriv1_o)
{
  Deriv1_o->_forward_m(this);
}

void
T1::dispatch_n(Base1 *Base1_o)
{
  Base1_o->_forward_n(this);
}

void
T1::dispatch_n(Base1 *Base1_o, int i)
{
  Base1_o->_forward_n(this, i);
}

void
T1::dispatch_n(Deriv1 *Deriv1_o)
{
  Deriv1_o->_forward_n(this);
}

void
T2::dispatch_m(Base1 *Base1_o)
{
  Base1_o->_forward_m(this);
}

void
T2::dispatch_n(Base1 *Base1_o)
{
  Base1_o->_forward_n(this);
}

void
T2::dispatch_n(Base1 *Base1_o, int i)
{
  Base1_o->_forward_n(this, i);
}

void
T3::dispatch_m(Deriv1 *Deriv1_o)
{
  Deriv1_o->_forward_m(this);
}

void
T3::dispatch_n(Deriv1 *Deriv1_o, int i)
{
  Deriv1_o->_forward_n(this, i);
}

void
T4::dispatch_m(Deriv2 *Deriv2_o)
{
  Deriv2_o->m(this);
}

void
T4::dispatch_n(Deriv2 *Deriv2_o, int i)
{
  Deriv2_o->n(this, i);
}

void
#line 52 "deriv2_private2.h"
Base1::m(T1 * t)
#line 52 "deriv2_private2.h"
{ std::cout << "Base1::m(T1)" << std::endl; }

void
#line 53 "deriv2_private2.h"
Base1::m(T2 * t)
#line 53 "deriv2_private2.h"
{ 
    // comment line
    std::cout << "Base1::m(T2)" << std::endl;
  }

void
Base1::m_DB(T1 * t)
{
  t->dispatch_m(this);
}

void
#line 60 "deriv2_private2.h"
Base1::n(T1 * t)
#line 60 "deriv2_private2.h"
{ std::cout << "Base1::n(T1)" << std::endl; }

void
#line 61 "deriv2_private2.h"
Base1::n(T2 * t)
#line 61 "deriv2_private2.h"
{ 
    // comment line
    std::cout << "Base1::n(T2)" << std::endl;
  }

void
#line 66 "deriv2_private2.h"
Base1::n(T1 * t, int i)
#line 66 "deriv2_private2.h"
{ std::cout << "Base1::n(T1,i)" << std::endl; }

void
#line 67 "deriv2_private2.h"
Base1::n(T2 * t, int i)
#line 67 "deriv2_private2.h"
{ 
    // comment line
    std::cout << "Base1::n(T2,i)" << std::endl;
  }

void
Base1::n_DB(T1 * t)
{
  t->dispatch_n(this);
}

void
Base1::n_DB(T1 * t, int i)
{
  t->dispatch_n(this, i);
}

void
Deriv1::m_DB(T1 * t)
{
  t->dispatch_m(this);
}

void
#line 103 "deriv2_private2.h"
Deriv1::n(T1 * tt)
#line 103 "deriv2_private2.h"
{ std::cout << "Deriv1::n(T1)" << std::endl; }

void
#line 104 "deriv2_private2.h"
Deriv1::n(T3 * t, int i)
#line 104 "deriv2_private2.h"
{ std::cout << "Deriv1::n(T3,i)" << std::endl; }

void
Deriv1::n_DB(T1 * tt)
{
  tt->dispatch_n(this);
}

void
Deriv1::n_DB(T3 * t, int i)
{
  t->dispatch_n(this, i);
}

void
#line 112 "deriv2_private2.h"
Deriv2::m(T4 * t)
#line 112 "deriv2_private2.h"
{ std::cout << "Deriv2::m(T4)" << std::endl; }

void
Deriv2::m_DB(T4 * t)
{
  t->dispatch_m(this);
}

void
#line 116 "deriv2_private2.h"
Deriv2::n(T4 * t, int i)
#line 116 "deriv2_private2.h"
{ std::cout << "Deriv2::n(T4,i)" << std::endl; }

void
Deriv2::n_DB(T4 * t, int i)
{
  t->dispatch_n(this, i);
}

