// use a class that specializes the same multimethod but with
// arguments belonging to two different hierarchies

int
main()
{
  TwoBases *b = new TwoBases2;

  FirstT1 *ft;
  SecondT1 *st;

  ft = new FirstT1;
  b->m_DB (ft);
  ft = new FirstT2;
  b->m_DB (ft);
  st = new SecondT1;
  b->m_DB (st);
  st = new SecondT2;
  b->m_DB (st);

  cout << endl;

  b = new TwoBases;

  ft = new FirstT1;
  b->m_DB (ft);
  ft = new FirstT2;
  b->m_DB (ft);
  st = new SecondT1;
  b->m_DB (st);
  st = new SecondT2;
  b->m_DB (st);

  FirstT1 *t1 = new FirstT1;
  FirstT1 *tt1 = new FirstT1;

  b->m_DB (t1, (int)10);
  b->m_DB (t1, (long)10.0);

  b->m_DB (t1, tt1);

  cout << "the following two invocations show that only double," << endl;
  cout << "and not multiple dispatch is implemented:" << endl;
  cout << "indeed the second parameter is FirstT2" << endl;
  tt1 = new FirstT2;
  b->m_DB (t1, tt1);
  b->m_DB (tt1, tt1);  

  return 0;
}
