// typical binary method example

#ifndef COLORPOINT_H
#define COLORPOINT_H

#include "point.hpp"

#include <string>

using std::string;

class ColorPoint : public Point
{
 protected:
  string color;

 public:
  ColorPoint(int i, int j, const string &c) :
    Point (i, j), color (c) {}

  branch equals
    bool (ColorPoint *p)
    {
      return (Point::equals (p) && color == p->color);
    };
  endbranch
};

#endif // COLORPOINT_H
