// test the use of super

#ifndef D_SUPER_H
#define D_SUPER_H

#include <iostream>

using std::cout;
using std::endl;

class T1
{
 public:
  virtual ~T1() {}

  virtual void foo1() { cout << "T1::foo1"; }
};

class T2 : public T1
{
 public:
  void foo1() { cout << "T2::foo1"; }
};

class B1
{
 public:
  virtual branch m
    virtual void (T1 *t) { cout << "B1::m(T1)" << endl; };
  endbranch

  virtual ~B1() {}
};

class B2 : public B1
{
 public:
  virtual branch m
    virtual void (T2 *t) 
    { 
      cout << "B2::m(T2)" << endl; 
      cout << "  "; 
      B1::m(t);
    };
  endbranch
};

#endif
