// multiple inheritance concerns target types

#ifndef DMUL_TARGET_H
#define DMUL_TARGET_H

#include <iostream>

using std::cout;
using std::endl;

class T1
{
 public:
  virtual void foo() {}

  virtual ~T1() {}
};

class T2
{
 public:
  virtual void bar() {}

  virtual ~T2() {}
};

class T3 : public T1, public T2
{

};

class C1
{
 public:
  virtual branch m
    virtual void (T1 *t) { cout << "C1::m(T1)" << endl; };
  endbranch

  virtual ~C1() {}
};

class C2 : public C1
{
 public:
  virtual branch m
    virtual void (T2 *t) { cout << "C2::m(T2)" << endl; };
  endbranch
};

class C3 : public C2
{
 public:
  virtual branch m
    virtual void (T3 *t) { cout << "C3::m(T3)" << endl; };
  endbranch
};

#endif // DMUL_TARGET_H
