/*
  The multimethod m is not declared virtual
 */

#ifndef NON_VIRTUAL_H
#define NON_VIRTUAL_H

#include <iostream>

using namespace std;

class T1
{
 public:
  virtual void foo() {}

  virtual ~T1() {}
};

class T2 : public T1 {};
class T3 : public T2 {};
class T4 : public T3 {};

class Base
{
 public:
  branches m
    void (T1 *) { cout << "Base::m(T1)" << endl; };
    void (T3 *) { cout << "Base::m(T3)" << endl; };
  endbranches

  virtual branches n
    void (T1 *) { cout << "Base::n(T1)" << endl; };
    void (T3 *) { cout << "Base::n(T3)" << endl; };
  endbranches

  virtual ~Base() {}
};

class Deriv : public Base
{
 public:
  branches m
    void (T2 *) { cout << "Deriv::m(T2)" << endl; };
    void (T4 *) { cout << "Deriv::m(T4)" << endl; };
  endbranches

  branches n
    void (T2 *) { cout << "Deriv::n(T2)" << endl; };
    void (T4 *) { cout << "Deriv::n(T4)" << endl; };
  endbranches
};

#endif // NON_VIRTUAL_H
