#ifndef O1_D_H
#define O1_D_H

#include <iostream>

class O1
{
 public:
  virtual ~O1() {}

  virtual void foo() { std::cout << "O1::foo" << std::endl; bar(); }
  virtual void bar() { std::cout << "O1::bar" << std::endl; }
};

class O1_d : public O1
{
 public:
  void bar() { std::cout << "O1_d::bar" << std::endl; }
};

class O2 : public O1_d
{
 public:
  void foo2() { std::cout << "O2::foo2" << std::endl; }
};

class O3 : public O2
{
 public:
  void foo3() { foo2(); }
};

class O4 : public O3
{
 public:
  void foo4() { std::cout << "O4::foo4" << std::endl; }
};

#endif
