/*
  This class defines branches for n that differ for the
  second paramater, so that two n_DB will be actually generated.
  The first parameters, instead, would still be related.
 */

#ifndef SLIGTHLY_DIFF
#define SLIGTHLY_DIFF

#include <iostream>

using namespace std;

class T {};

class S {};

class S1 {
 public:
  virtual void foo() {}

  virtual ~S1() {}
};

class S2 : public S1 {};

class S3 : public S2 {};

class V1 {
 public:
  virtual void bar() {}

  virtual ~V1() {}
};

class V2 : public V1 {};

class Slightly_Diff
{
public:
  virtual branch n
   virtual S (S1 *t, V1 *v) { cout << "A::n(S1, V1)" << endl; S s; return s; };
   virtual S (S2 *t, V1 *v) { cout << "A::n(S2, V1)" << endl; S s; return s; };
   virtual T (S2 *t, V2 *v) { cout << "A::n(S2, V2)" << endl; T x; return x; };
   virtual T (S3 *t, V2 *v) { cout << "A::n(S3, V2)" << endl; T x; return x; };
  endbranch

  virtual ~Slightly_Diff() {}
};

#endif // SLIGTHLY_DIFF
